#!/usr/bin/perl -w
use strict;

# to the about window
my $about_window;
my $about_button;
my $about_text;
my $about_table;

my $file_dialog;

#my $data;
#my $data={0,0};

$main::tmp_filename="/tmp/gsubshift-tmp1.sub";
$main::tmp2_filename="/tmp/gsubshift-tmp2.sub";
$main::orig_filename="";

sub readFileToCList
{
  my ($fn) = @_;
  print "$fn\n";
  $main::clist_subs->clear();
  my $i=0;
  open IFILE, "$fn" or die("Couldn't open $fn\n") ;
  while ($main::test = readline(IFILE))
  {
    $main::line = $main::test;
	 @main::line_t1 = split(/}/, $main::line);
	  @main::line_t2 = split(/{/, $main::line_t1[0]);
	  @main::line_t3 = split(/{/, $main::line_t1[1]);

          $main::substart[$i] = $main::line_t2[1];
	  $main::substop[$i] = $main::line_t3[1];
	  $main::subs[$i++] = $main::line_t1[2];
        }
	$i=0;
	while($main::substart[$i])
	  {
	   $main::clist_subs->append( ($main::substart[$i], $main::substop[$i], $main::subs[$i] ));
	  #  print "{$main::substart[$main::i]}{$main::substop[$main::i]}$main::subs[$main::i]\n";
	    $i++;
	}
       close(IFILE);
	$main::shift_item->set_sensitive(1);
	$main::button_shift->set_sensitive(1);

}

sub quitProgram
{
	Gtk->exit(0);
	return 0;
}

sub fileOpenOK
{
 	# gots selected file
 	$main::filename = $file_dialog->get_filename();
	$file_dialog->destroy();

        $main::orig_filename = $main::filename;
	$main::label_filename->set_text($main::filename);
	
	&readFileToCList($main::filename);
	return 0;
}

sub fileSaveOK
{
 	# gots selected file
 	$main::filename = $file_dialog->get_filename();
	$file_dialog->destroy();

        $main::orig_filename = $main::filename;
	system("cp $main::tmp_filename $main::filename");

	return 0;
}

sub fileReread
{
  $main::filename=$main::orig_filename;
  &readFileToCList($main::orig_filename);
  return 0;
}

sub fileC
{
 	# gots selected file
	$file_dialog->destroy();
	return 0;
}

sub fileOpen
{
	$file_dialog = new Gtk::FileSelection("Open subtitle");
	$file_dialog->complete( "*.sub" );
	$file_dialog->ok_button->signal_connect( "clicked", \&fileOpenOK, $file_dialog );
	$file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

	$file_dialog->show();

	return 0;
}

sub fileSave
{
	$file_dialog = new Gtk::FileSelection("Save subtitle");
	$file_dialog->complete( "*.sub" );
	$file_dialog->ok_button->signal_connect( "clicked", \&fileSaveOK, $file_dialog );
	$file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

	$file_dialog->show();
	return 0;
}

sub about
{
	# creates about window
	$about_window = new Gtk::Window("dialog");
	$about_window->set_title("About GTK SubShifter");
	$about_button = new Gtk::Button("OK");
	$about_window->signal_connect( "delete_event", \&closeAbout );
	$about_button->signal_connect( "clicked", \&closeAbout );

	$about_button->show();
	$about_window->set_modal( 1 );
	$about_window->add($about_button);

	$about_window->show();
	return 0;
}

sub closeAbout
{
	$about_window->destroy();
	return 0;
}

sub shifting
{
  my $time = $main::adj_time->value;
  my $start = $main::adj_start->value;
  my $end = $main::adj_end->value;
  my $line;

  print "Shifting ;)\n";
  ## TODO
  ## convertation code here
  ##	$main::filename;
  if( ($main::filename) && ( $time != 0 ) )
  {
    if($main::filename eq $main::tmp2_filename)
      {
	system("mv $main::filename $main::tmp2_filename");
      }
    else
      {
	system("cp $main::filename $main::tmp2_filename");
      }
    $main::filename = $main::tmp2_filename;

    if($time<0)
    {
      $time = -$time;
      $line = "./subshift.pl -t $time -s $start -e $end -i $main::filename -o $main::tmp_filename -d";
    }
    else
    {
      $line = "./subshift.pl -t $time -s $start -e $end -i $main::filename -o $main::tmp_filename";
    }
    print "$line\n";
    system($line);

    $main::filename = $main::tmp_filename;
    &readFileToCList($main::filename);

    $main::reread_item->set_sensitive(1);
    $main::save_item->set_sensitive(1);
  }

  return 0;
}

sub select_row
  {
    my ( $widget, $row, $column, $event, @data ) = @_;

    $main::text_start = $widget->get_text( $column, 0 );
    $main::text_end = $widget->get_text( $column, 1 );
    $main::text_text = $widget->get_text( $column, 2 );

  }

sub toStart
{
  $main::adj_start->set_value($main::text_start);
  return 0;
}

sub toEnd
{
  $main::adj_end->set_value( $main::text_end);
	return 0;
}

1;
